// dibapi.h

#ifndef _INC_DIBAPI
#define _INC_DIBAPI

/* Handle to a DIB */
DECLARE_HANDLE(HDIB);

/* DIB constants */
#define PALVERSION   0x300

/* DIB Macros*/

#define IS_WIN30_DIB(lpbi)  ((*(LPDWORD)(lpbi)) == sizeof(BITMAPINFOHEADER))
#define RECTWIDTH(lpRect)     ((lpRect)->right - (lpRect)->left)
#define RECTHEIGHT(lpRect)    ((lpRect)->bottom - (lpRect)->top)

// WIDTHBYTES performs DWORD-aligning of DIB scanlines.  The "bits"
// parameter is the bit count for the scanline (biWidth * biBitCount),
// and this macro returns the number of DWORD-aligned bytes needed
// to hold those bits.

#define WIDTHBYTES(bits)    (((bits) + 31) / 32 * 4)

/* Function prototypes */
BOOL      WINAPI  PaintDIB (HDC, LPRECT, HDIB, LPRECT, CPalette* pPal);
BOOL      WINAPI  CreateDIBPalette(HDIB hDIB, CPalette* cPal);
LPSTR     WINAPI  FindDIBBits (LPSTR lpbi);
DWORD     WINAPI  DIBWidth (LPSTR lpDIB);
DWORD     WINAPI  DIBHeight (LPSTR lpDIB);
WORD      WINAPI  PaletteSize (LPSTR lpbi);
WORD      WINAPI  DIBNumColors (LPSTR lpbi);
HANDLE    WINAPI  CopyHandle (HANDLE h);    
BOOL			WINAPI	DIBtoDDB(HGLOBAL hD,CBitmap* pB,CWnd* pW,CPalette* pP,CRect sr);      
HGLOBAL	  WINAPI  DDBtoDIB(CBitmap* pBmp, CPalette* pPal,CDC* pDC); 
DWORD     WINAPI  CalcDIBBits(DWORD W,DWORD H,DWORD R);

BOOL      WINAPI  SaveDIB (HDIB hDib, CFile& file);
HDIB      WINAPI  ReadDIBFile(CFile& file); 
HDIB			WINAPI  LoadDIBFile(PSTR fname, DWORD ofsstart);
void 			WINAPI	GetDIBScale(HGLOBAL H,CDC* pDC, CWnd* pWnd, LONG& X, LONG& Y);
HGLOBAL WINAPI DIBtoPICT(HGLOBAL hDIB, CDC* pDC,CWnd* pWnd);
#endif //!_INC_DIBAPI
